/* structures for filefind */

/* point to unused memory below SYS programs
   that I also use for a transfer area between AUXMEM and MAINMEM */

struct filefind *ff = (struct filefind *)4192;
struct fileinfo *fi = (struct fileinfo *)4192;

/* make a piclist if it does not already exist... look for files in
   the current directory that match the criteria for our loader. */

FILE *makepiclist()
{
	FILE *fp = NULL;
	char *ext = NULL, *f=NULL, picname[20], filext[16];
	int filetype = 6, err, ferr=0, cnt=0, filematch, i, j;

	if((fp=fopen("PICLIST","w"))==NULL) return fp;

	/* look for Hi-Res Graphics files and add to piclist */
	err = gfindopen(f,fi);

	if (err > -1) {
		while (gfindnext(filetype, ext, picname,ff) == 0){

			/* check for a2fc images and bin and aux image pairs
			   there is no way to tell the difference between a
			   hi-res bsaved image and a double hi-res bin or aux image */
			if (ff->address != 0x2000 && ff->address != 0x4000) continue;
			if (ff->size != 8192 && ff->size != 16384) continue;

			strupr(picname); /* change all filenames to upper case */
			filematch = 1;

			/* bypass AUX files - I only want BIN files in my list */
			if (ff->size == 8192) {
				/* get picname extension */
				j = -1;
				filext[0] = 0;
				for (i = 0; picname[i] != 0; i++) {
				   if (j > -1) {
					   filext[j] = toupper(picname[i]);
					   j++;
					   filext[j] = 0;
				   }
				   if (picname[i] == '.') j = 0;
				}
				if (filext[0] == 'A' && filext[1] == 'U' && filext[2] == 'X' && filext[3] == 0)
				  filematch = 0;
			}

			if (filematch != 0) {
				/* if out of disk space quit writing to piclist */
				ferr = fputs(picname,fp);
				if (ferr != -1) ferr = aputc('\n',fp);
				if (ferr != -1) cnt++;
				else break;
			}
		}
	}

	fclose(fp);
	if (cnt > 0) fp=fopen("PICLIST","r");
	else {
		/* if no files found or no picnames written
		   remove empty piclist */
		unlink("PICLIST");
		fp = NULL;
	}


	return fp;
}

