/* structures for filefind */

/* point to unused memory below SYS programs
   that I also use for a transfer area between AUXMEM and MAINMEM */
   
struct filefind *ff = (struct filefind *)4192;
struct fileinfo *fi = (struct fileinfo *)4192;

/* make a piclist if it does not already exist... look for files in
   the current directory that match the criteria for our loader. */

FILE *makepiclist()
{
	FILE *fp = NULL;
	char *ext = NULL, *f=NULL, picname[16], filext[16];
	int filetype = 6, err, ferr=0, cnt=0, filematch, i, j;

	if((fp=fopen("PIXLIST","w"))==NULL) return fp;

	/* look for Hi-Res Graphics files and add to piclist */
	err = gfindopen(f,fi);

	if (err > -1) {
		while (gfindnext(filetype, ext, picname,ff) == 0){
			/* get picname extension */
			j = -1;
			filext[0] = 0;
			for (i = 0; picname[i] != 0; i++) {
			   if (j > -1) {
				   filext[j] = toupper(picname[i]);
				   j++;
				   filext[j] = 0;
			   }
			   if (picname[i] == '.') j = 0;
			}

			filematch = 0;

			/* check for bsaved images first and raster images next */
			if ((ff->size > 8183 && ff->size < 8193) && (ff->address == 0x2000 || ff->address == 0x4000))
				filematch = 1;
			else if (filext[0] == 'T' && filext[1] == 'O' && filext[2] == 'P' &&
				filext[3] == 0 && ff->size == 6402) filematch = 1;
			else if (filext[0] == 'B' && filext[1] == 'O' && filext[2] == 'T' &&
				filext[3] == 0 && ff->size == 7682) filematch = 1;
			else if (filext[0] == 'R' && filext[1] == 'A' && filext[2] == 'G' &&
				filext[3] == 0 && (ff->size > 2 && ff->size < 7683)) filematch = 1;
			else if (filext[0] == 'R' && filext[1] == 'A' && filext[2] == 'X' &&
				filext[3] == 0 && ff->size > 2) filematch = 1;

			if (filematch != 0) {
				/* if out of disk space quit writing to piclist */
				ferr = fputs(picname,fp);
				if (ferr != -1) ferr = aputc((char)13,fp);
				if (ferr != -1) cnt++;
				else break;
			}
		}
	}

	fclose(fp);
	if (cnt > 0) fp=fopen("PIXLIST","r");
	else {
		/* if no files found or no picnames written
		   remove empty piclist */
		unlink("PICLIST");
		fp = NULL;
	}


	return fp;
}

